import 'dart:ui';

import 'package:fis_jsonrpc/rpc.dart';

abstract class IURMDataProcessor {
  URMMeasureParams getURMMeasureParams();
  Rect get measureAreaInFullVisual; // 当前可测量区域在完整视图中的归一化矩形
  Rect get urmScreenInFullVisual; // 当前URM视图在完整视图中的归一化矩形
  double get fullVisualPhywidth; // 完整视图的图像物理宽度
  bool get showLeftRight; // 是否显示左右双幅
  bool get isLeftRight; // 是否左右双幅的图像 (不考虑同步显示的情况)
}

class URMMeasureParams {
  String remedicalCode = ""; // 手动取值
  String urmImageType = "1"; // 手动取值
  bool urmBlend = false; // 手动取值
  double downsampleIndex = 0; // 手动取值
  double intPowerDen = 0; // 手动取值
  double intPowerDir = 0; // 手动取值
  double sigmaGauss = 0; // 手动取值
  double vessScale = 0; // 手动取值
  double velMaxScaler = 0; // 手动取值
  double velMinScaler = 0; // 手动取值
  double iterations = 0; // 手动取值
  int imgProcessVer = 0; // 手动取值
  bool zoomOn = false; // 手动取值
  double zoomRoix = 0; // 手动取值
  double zoomRoiy = 0; // 手动取值
  double zoomRoiwidth = 0; // 手动取值
  double zoomRoiheight = 0; // 手动取值
  int roix = 0; // 手动取值
  int roiy = 0; // 手动取值
  int roiwidth = 0; // 手动取值
  int roiheight = 0; // 手动取值
  bool leftRight = false; // 手动取值
  bool upDown = false; // 手动取值
  int screenWidth = 0; // 手动取值
  int screenHeight = 0; // 手动取值
  List<UrmPoint>? urmTraceDPoints; // 手动取值
  URMMeasureParams({
    required this.remedicalCode,
    required this.urmImageType,
    required this.urmBlend,
    required this.downsampleIndex,
    required this.intPowerDen,
    required this.intPowerDir,
    required this.sigmaGauss,
    required this.vessScale,
    required this.velMaxScaler,
    required this.velMinScaler,
    required this.iterations,
    required this.imgProcessVer,
    required this.zoomOn,
    required this.zoomRoix,
    required this.zoomRoiy,
    required this.zoomRoiwidth,
    required this.zoomRoiheight,
    required this.roix,
    required this.roiy,
    required this.roiwidth,
    required this.roiheight,
    required this.leftRight,
    required this.upDown,
    required this.screenWidth,
    required this.screenHeight,
    required this.urmTraceDPoints,
  });
}
