import 'package:fis_jsonrpc/rpc.dart';
import 'package:fis_measure/interfaces/process/workspace/application.dart';
import 'package:fis_measure/interfaces/date_types/point.dart';
import 'package:fis_measure/process/primitives/multi_method/dop_trace_disp/cardiac_cycle.dart';
import 'package:get/get.dart';

class TraceListData {
  VetAutoTraceImageResult? _vetAutoTraceImageResult;
  VetAutoTraceImageResult? get vetAutoTraceImageResult =>
      _vetAutoTraceImageResult;

  TraceListData._internal() {
    setLocation(_currentType);
    localData();
    getCardiacCycles();
  }

  static final List<DPoint> _maxPonints = [];
  static List<CardiacCycle> _cardiacCycleList = [];

  TraceLocationType _currentType = TraceLocationType.below;

  static List<DPoint> belowList = [];
  static List<DPoint> aboveList = [];
  static List<DPoint> bothList = [];

  static List<DPoint> initList = [];
  List<DPoint> get maxPonints => _maxPonints;

  List<CardiacCycle> get cardiacCycleList => _cardiacCycleList;

  void setLocation(TraceLocationType type) {
    aboveList = belowList;
    if (type == TraceLocationType.above) {
      initList = aboveList;
    } else if (type == TraceLocationType.below) {
      initList = belowList;
    } else if (type == TraceLocationType.both) {
      initList = bothList;
    }
    _currentType = type;
  }

  static List<DPoint> localData() {
    for (int i = 0; i < initList.length; i++) {
      _maxPonints.add(convert(initList[i]));
    }
    return _maxPonints;
  }

  List<CardiacCycle> getCardiacCycles() {
    _cardiacCycleList = [];
    return _cardiacCycleList;
  }

  static DPoint convert(
    DPoint point,
  ) {
    /// 像素坐标
    final x = point.x;
    final y = point.y;
    final widthScale = Get.find<IApplication>().displayScaleRatio;

    return DPoint(x * widthScale, y * widthScale);
  }

  static final TraceListData _instance = TraceListData._internal();

  static TraceListData get instance => _instance;

  void setVetAutoTraceImageResult(VetAutoTraceImageResult? result) {
    _vetAutoTraceImageResult = result;
  }
}

enum TraceLocationType {
  below,
  above,
  both,
}
