import 'package:fis_measure/interfaces/enums/items.dart';
import 'package:fis_measure/interfaces/process/items/item.dart';
import 'package:fis_measure/interfaces/process/items/item_metas.dart';
import 'package:fis_measure/interfaces/process/workspace/point_info.dart';
import 'package:fis_measure/process/calcuators/urm_calcuators/urm_location_vel.dart';
import 'package:fis_measure/process/primitives/location.dart';
import 'package:fis_measure/utils/prompt_box.dart';

class URMLocationVelMeasure extends Location {
  URMLocationVelMeasure(super.meta, super.parent);

  static URMLocationVelMeasure createURMLocationVelMeasure(ItemMeta meta,
      [IMeasureItem? parent]) {
    URMLocationVelMeasure measureLocationVel =
        URMLocationVelMeasure(meta, parent);

    measureLocationVel.calculator = URMLocationVelCal(
      measureLocationVel,
    );
    return measureLocationVel;
  }

  @override
  bool onExecuteMouse(PointInfo args) {
    if (state == ItemStates.finished || state == ItemStates.waiting) {
      if (args.pointType == PointInfoType.mouseMove) {
        handleMouseMoveWhileFinish(args);
      }
    }
    if (state == ItemStates.running) {
      if (args.pointType == PointInfoType.mouseUp) return false;

      feature?.point = args;
      doCalculate();
      if (args.pointType == PointInfoType.mouseDown) {
        handleFinish();
      }
    }
    return true;
  }

  bool waitingResult = false;

  @override
  void handleMouseMoveWhileFinish(PointInfo args) {
    // TODO: 判断是否当前 area
    // 转换为 Area 逻辑位置
    final point = args.toAreaLogicPoint();
    handleTissue(args, point);
    handleTissueTM(args.hostVisualArea!.mode.modeType, point);
    if (args.hostVisualArea != null) {
      feature!.hostVisualArea = args.hostVisualArea;
    }
    state = ItemStates.running;
  }

  void handleFinish() async {
    feature!.isActive = false;
    waitingResult = true;
    await doCalculateAsync();
    doFeatureFinish();
    doFeatureUpdate(); // 若不执行，子测量将无法自动切换
    PromptBox.dismiss();
    waitingResult = false;
  }
}
